               /*Ŀ
                                                                        
                    drawArc() = draws an arc centered at (xc,yc) with   
                                radius 'b' in y direction from starting 
                                angle  'start_angle' in tenths of a     
                                degree to ending angle 'end_angle' in   
                                tenths of a degree with aspect ratio    
                                'aspect' and in color 'color'.          
                                                                        
                 */

#include <math.h>
#include "gdraws.h"

extern int LINEWIDTH;

void drawArc (int xc, int yc, int b, int start_angle,int end_angle,
	     int color, float aspect)

{
	int i, start_sector,end_sector,x_start_test,x_end_test;
	int arcTest[9],j;
        float a_temp;
	long a_square, b_square, two_a_square, two_b_square, four_a_square,
             four_b_square,d,a,row,col;

	void plotArc1 (int x, int y, int sector, int color,
	     int arcTest[], int x_start_test, int x_end_test);
	void plotArc2 (int x, int y, int sector, int color,
	     int arcTest[], int x_start_test, int x_end_test);

	for (i=0; i<8; i++)
		arcTest[i] = 0;
	xc = ((xc + 319)*18) >> 4;
	yc = 174 - ((93*yc) >> 7);
	a_temp = b/aspect;
	a = (((int)(a_temp * 18)) >> 4) - LINEWIDTH/2;
	b = ((93*b) >> 7) - LINEWIDTH/2;
	for (j=0; j<LINEWIDTH; j++,a++,b++)
	{
		b_square = b*b;
		a_square = a*a;
		row = b;
		col = 0;
		two_a_square = a_square << 1;
		four_a_square = a_square << 2;
		four_b_square = b_square << 2;
		two_b_square = b_square << 1;
		d = two_a_square * ((row  -1)*(row )) + a_square +
		    two_b_square*(1-a_square);
		start_sector = start_angle/450;
		end_sector = end_angle/450;
		x_start_test = xc+sqrt(a_square)*cos(start_angle*.0017453);
		x_end_test = xc+sqrt(a_square)*cos(end_angle*.0017453);
		if (start_sector == end_sector)
			arcTest[start_sector] = 4;
		else
		{
			arcTest[start_sector] = 1;
	        	arcTest[end_sector] = 3;
        		for (i=start_sector+1; i!=end_sector; i++)
        		{
	        		arcTest[i] = 2;
        			if (i==8)
        				i=-1;
        		}
	        }
		while (a_square*(row ) > b_square * (col))
		{
			plotArc1 (xc+col, yc-row, 6, color, arcTest, x_start_test,
                	         x_end_test);
			plotArc2 (xc+col, yc+row, 1, color, arcTest, x_start_test,
        	                 x_end_test);
			plotArc1 (xc-col, yc-row, 5, color, arcTest, x_start_test,
                        	 x_end_test);
	     		plotArc2 (xc-col, yc+row, 2, color, arcTest, x_start_test,
        	                 x_end_test);
			if (d>= 0)
			{
				row--;
				d -= four_a_square*(row);
			}
			d += two_b_square*(3 + (col << 1));
			col++;
		}
		d = two_b_square * (col + 1)*col + two_a_square*(row *
                	(row  -2) +1) + (1-two_a_square)*b_square;
		while ((row) + 1)
		{
			plotArc1 (xc+col, yc-row, 7, color, arcTest, x_start_test,
                        	 x_end_test);
			plotArc2 (xc+col, yc+row, 0, color, arcTest, x_start_test,
        	                 x_end_test);
			plotArc1 (xc-col, yc-row, 4, color, arcTest, x_start_test,
                        	 x_end_test);
	     		plotArc2 (xc-col, yc+row, 3, color, arcTest, x_start_test,
        	                 x_end_test);
			if (d<= 0)
			{
				col++;
				d += four_b_square*col;
			}
			row--;
			d += two_a_square * (3 - (row <<1));
		}
	}
}


void plotArc1 (int x, int y, int sector, int color,
	     int arcTest[], int x_start_test, int x_end_test)
{
	if (arcTest[sector] == 0)
		return;
	if (arcTest[sector] == 2)
		plot(x,y,color);
	if ((arcTest[sector] == 1) && (x>=x_start_test))
		plot(x,y,color);
	if ((arcTest[sector] == 3) && (x<=x_end_test))
		plot(x,y,color);
	if ((arcTest[sector] == 4) && (x>=x_start_test) && (x<=x_end_test))
		plot(x,y,color);
}
void plotArc2 (int x, int y, int sector, int color,
	     int arcTest[], int x_start_test, int x_end_test)
{
	if (arcTest[sector] == 0)
		return;
	if (arcTest[sector] == 2)
		plot(x,y,color);
	if ((arcTest[sector] == 1) && (x<=x_start_test))
		plot(x,y,color);
	if ((arcTest[sector] == 3) && (x>=x_end_test))
		plot(x,y,color);
	if ((arcTest[sector] == 4) && (x>=x_end_test) && (x<=x_start_test))
		plot(x,y,color);
}
