               /*Ŀ
                                                                        
                    fillArc() = fills an arc centered at (xc,yc) having 
                                radius 'b' in y direction from starting 
                                angle  'start_angle' in tenths of a     
                                degree to ending angle 'end_angle' in   
                                tenths of a degree and aspect ratio     
                                'aspect' with   color 'color'.          
                                                                        
                 */

#include <math.h>
#include "gdraws.h"
#include <dos.h>



void fillArc (int xc, int yc, int b, int start_angle,int end_angle,
	     int color, float aspect)

{
	int col, i, row,start_sector,end_sector,x_start_test,x_end_test;
	int arcTest[9];
        float aspect_square;
	long a_square, b_square, two_a_square, two_b_square, four_a_square,
             four_b_square,d;

	for (i=0; i<8; i++)
		arcTest[i] = 0;
	aspect_square = aspect*aspect;
	a_square = b*b/aspect_square;

	#ifdef CGA
	a_square >>= 2;
	b = (53*b) >> 7;
	#endif

	#ifdef EGA
	b = (93*b) >> 7;
	#endif

	b_square = b*b;
	row = b;
	col = 0;
	convert(xc,yc);
	two_a_square = a_square << 1;
	four_a_square = a_square << 2;
	four_b_square = b_square << 2;
	two_b_square = b_square << 1;
	d = two_a_square * ((row  -1)*(row )) + a_square +
	    two_b_square*(1-a_square);
	start_sector = start_angle/450;
	end_sector = end_angle/450;
	x_start_test = xc+sqrt(a_square)*cos(start_angle*.0017453);
	x_end_test = xc+sqrt(a_square)*cos(end_angle*.0017453);
	if (start_sector == end_sector)
		arcTest[start_sector] = 4;
	else
	{
		arcTest[start_sector] = 1;
        	arcTest[end_sector] = 3;
        	for (i=start_sector+1; i!=end_sector; i++)
        	{
        		arcTest[i] = 2;
        		if (i==8)
        			i=-1;
        	}
        }
	while (a_square*(row ) > b_square * (col))
	{
		fillArc1 (xc,yc,xc+col, yc+row, 6, arcTest, x_start_test,
                         x_end_test,color);
		fillArc1 (xc,yc,xc+col, yc-row, 1, arcTest, x_start_test,
                         x_end_test,color);
		fillArc1 (xc,yc,xc-col, yc+row, 5, arcTest, x_start_test,
                         x_end_test,color);
     		fillArc1 (xc,yc,xc-col, yc-row, 2, arcTest, x_start_test,
                         x_end_test,color);
		if (d>= 0)
		{
			row--;
			d -= four_a_square*(row);
		}
		d += two_b_square*(3 + (col << 1));
		col++;
	}

	d = two_b_square * (col + 1)*col + two_a_square*(row *
                (row  -2) +1) + (1-two_a_square)*b_square;
	while ((row) + 1)
	{
		fillArc1 (xc,yc,xc+col, yc+row, 7, arcTest, x_start_test,
                         x_end_test,color);
		fillArc1 (xc,yc,xc+col, yc-row, 0, arcTest, x_start_test,
                         x_end_test,color);
		fillArc1 (xc,yc,xc-col, yc+row, 4, arcTest, x_start_test,
                         x_end_test,color);
     		fillArc1 (xc,yc,xc-col, yc-row, 3, arcTest, x_start_test,
                         x_end_test,color);
		if (d<= 0)
		{
			col++;
			d += four_b_square*col;
		}
		row--;
		d += two_a_square * (3 - (row <<1));
	}
}

               /*Ŀ
                                                                        
                    fillArc1() = subroutine for fillArc                 
                                                                        
                 */



void fillArc1 (int xc, int yc,int x, int y, int sector,
	     int arcTest[], int x_start_test, int x_end_test, int color)
{

	union REGS reg;
	#define seq_out(index,val)  {outp(0x3C4,index);\
					 outp(0x3C5,val);}
	#define graph_out(index,val)  {outp(0x3CE,index);\
					 outp(0x3CF,val);}

	unsigned int offset;
	int dummy, mask,dx,dy,i,tx=0,ty=0,sdx,sdy,dxabs,dyabs;
	char far * mem_address;

	switch (sector)
	{
		case 4:
  		case 5:
  		case 6:
  		case 7:
		if (arcTest[sector] == 2)
			break;
		if ((arcTest[sector] == 1) && (x>=x_start_test))
			break;
		if ((arcTest[sector] == 3) && (x<=x_end_test))
			break;
		if ((arcTest[sector] == 4) && (x>=x_start_test)
                   && (x<=x_end_test))
			break;
		return;
		case 0:
		case 1:
		case 2:
		case 3:
		if (arcTest[sector] == 2)
			break;
		if ((arcTest[sector] == 1) && (x<=x_start_test))
        		break;
        	if ((arcTest[sector] == 3) && (x>=x_end_test))
        		break;
        	if ((arcTest[sector] == 4) && (x>=x_end_test)
        		&& (x<=x_start_test))
			break;
		return;
	}
	if ((sector <= 1) || (sector >= 6))
		sdx = 1;
	else
		 sdx = -1;
	if (sector > 3)
		sdy = 1;
	else
		sdy = -1;
	dxabs = (x-xc)*sdx;
	dyabs = (y-yc)*sdy;
	if (dxabs >= dyabs)
	{
		for (i=0; i<= dxabs; i++)
		{
			ty+= dyabs;
			if (ty>dxabs)
			{
				ty -= dxabs;
				yc +=sdy;
			}
			#ifdef CGA
			plot(xc,yc,color);
			plot(xc,yc+1,color);
			#endif

			#ifndef CGA
			offset = (long)yc * 80L + ((long)xc / 8L);
			mem_address = (char far *) 0xA0000000L + offset;
			mask = 0x80 >> (xc % 8);
			graph_out(8,mask);
			seq_out(2,0x0F);
			dummy = *mem_address;
			*mem_address = 0;
			seq_out(2,color);
			*mem_address = 0xFF;
			offset = (long)(yc + 1) * 80L + ((long)xc / 8L);
			mem_address = (char far *) 0xA0000000L + offset;
			graph_out(8,mask);
			seq_out(2,0x0F);
			dummy = *mem_address;
			*mem_address = 0;
			seq_out(2,color);
			*mem_address = 0xFF;
			seq_out(2,0x0F);
			graph_out(3,0);
			graph_out(8,0xFF);
			#endif
			xc+= sdx;
		}
	}
	else
	{
		for (i=0; i<= dyabs; i++)
		{
			tx+= dxabs;
			if (tx>dyabs)
			{
				tx -= dyabs;
				xc +=sdx;
			}
			#ifdef CGA
			plot(xc,yc,color);
			plot(xc+1,yc,color);
			#endif

			#ifndef CGA
			offset = (long)yc * 80L + ((long)xc / 8L);
			mem_address = (char far *) 0xA0000000L + offset;
			mask = 0x80 >> (xc % 8);
			graph_out(8,mask);
			seq_out(2,0x0F);
			dummy = *mem_address;
			*mem_address = 0;
			seq_out(2,color);
			*mem_address = 0xFF;
			offset = (long)yc * 80L + ((long)(xc + 1) / 8L);
			mem_address = (char far *) 0xA0000000L + offset;
			mask = 0x80 >> ((xc + 1) % 8);
			graph_out(8,mask);
			seq_out(2,0x0F);
			dummy = *mem_address;
			*mem_address = 0;
			seq_out(2,color);
			*mem_address = 0xFF;
			seq_out(2,0x0F);
			graph_out(3,0);
			graph_out(8,0xFF);
			#endif
			yc+= sdy;
		}

	}
}
