#include <dos.h>

               /*Ŀ
                                                                        
                  setColorPageMode() = sets the color paging mode       
                                    number.                             
                                                                        
                 */

#include "gtools.h"

void setColorPageMode(int mode)
{

	union REGS reg;

	reg.x.ax = 0x1013;
	reg.h.bh = mode;
	reg.h.bl = 0;
	int86(0x10,&reg,&reg);
}
               /*Ŀ
                                                                        
                  setColorPage() = sets page of color registers         
                                                                        
                 */


void setColorPage(int page_no)
{

	union REGS reg;

	reg.x.ax = 0x1013;
	reg.h.bh = page_no;
	reg.h.bl = 1;
	int86(0x10,&reg,&reg);
}
               /*Ŀ
                                                                        
                    readColorReg() = Reads Individual Color Register    
                                     Settings                           
                                                                        
                 */


void readColorReg(int color_reg, int *red, int *green, int *blue)
{

	union REGS reg;

	reg.x.ax = 0x1015;
	reg.x.bx = color_reg;
	int86(0x10,&reg,&reg);
	*green = reg.h.ch;
	*blue = reg.h.cl;
	*red = reg.h.dh;
}
               /*Ŀ
                                                                        
                    writeColorReg() = Writes Color Data to Individual   
                                      Color Register                    
                                                                        
                 */


void writeColorReg(int color_reg, int red, int green, int blue)
{

	union REGS reg;

	reg.x.ax = 0x1010;
	reg.x.bx = color_reg;
	reg.h.ch = green;
	reg.h.cl = blue;
	reg.h.dh = red;
	int86(0x10,&reg,&reg);
}

